#include <stdlib.h>
#include <string.h>

/*
 * Copy a string and return a pointer to the new storage allocated
 * to contain it. This function differs from strcpy(3) in that it
 * allocates the necessary storage instead of just copying into
 * storage provided by the caller.
 */

char *
copy_string(char *string)
{
  char *new;
   
  if((new = (char *) malloc( (size_t) (strlen(string) + 1) ) ) != (char *) 0){
    strcpy(new,string);
  }
  return(new);
}

/*
 * Allocate storage for a string of the required length and
 * return a pointer to it. The string is initialized to null
 * by placing a null character in its first byte.
 */

char *
create_string(int length)
{
  char *nptr;

  nptr = (char *) malloc( (size_t) (length + 1));
  if(nptr != (char *) 0) nptr[0] = '\0';
  return(nptr);
}
